; RipeMD128 func stolen from ReWolf's crackme.
; slightly modified for use in C code

.586
.model flat, C

.data
dword_404260    dd 0
byte_404264     db 80h dup(?)
dword_4042E4    dd 0
dword_4042E8    dd 0
dword_4042EC    dd 0 
dword_4042F0    dd 0
dword_4042F4    dd 0
dword_4042F8    dd 0
dword_4042FC    dd 0
dword_404300    dd 0
dword_404304    dd 0 
dword_404308    dd 0 
byte_40430C     db 0

.code
RIPEMD128	proc
input		= dword	ptr  4
inputlen	= dword	ptr  8
hashresult	= dword	ptr  0Ch

		pusha
		cld
		mov	ecx, [esp+20h+inputlen]
		mov	esi, [esp+20h+input]
		mov	ds:dword_404304, ecx
		mov	ds:byte_40430C,	1
		mov	ds:dword_404308, ecx
		mov	ds:dword_4042E4, 67452301h
		mov	ds:dword_4042E8, 0EFCDAB89h
		mov	ds:dword_4042EC, 98BADCFEh
		mov	ds:dword_4042F0, 10325476h

loc_401045:
		cmp	ds:dword_404308, 40h
		jb	loc_401B85
		mov	eax, ds:dword_4042E4
		mov	ebx, ds:dword_4042E8
		mov	ecx, ds:dword_4042EC
		mov	edx, ds:dword_4042F0
		mov	edi, ebx
		add	eax, [esi]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 0Bh
		mov	edi, eax
		add	edx, [esi+4]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 0Eh
		mov	edi, edx
		add	ecx, [esi+8]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 0Fh
		mov	edi, ecx
		add	ebx, [esi+0Ch]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 0Ch
		mov	edi, ebx
		add	eax, [esi+10h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 5
		mov	edi, eax
		add	edx, [esi+14h]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 8
		mov	edi, edx
		add	ecx, [esi+18h]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 7
		mov	edi, ecx
		add	ebx, [esi+1Ch]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 9
		mov	edi, ebx
		add	eax, [esi+20h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 0Bh
		mov	edi, eax
		add	edx, [esi+24h]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 0Dh
		mov	edi, edx
		add	ecx, [esi+28h]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 0Eh
		mov	edi, ecx
		add	ebx, [esi+2Ch]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 0Fh
		mov	edi, ebx
		add	eax, [esi+30h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 6
		mov	edi, eax
		add	edx, [esi+34h]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 7
		mov	edi, edx
		add	ecx, [esi+38h]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 9
		mov	edi, ecx
		add	ebx, [esi+3Ch]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 8
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+1Ch]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+5A827999h]
		rol	eax, 7
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+10h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+5A827999h]
		rol	edx, 6
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+34h]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+5A827999h]
		rol	ecx, 8
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+4]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+5A827999h]
		rol	ebx, 0Dh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+28h]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+5A827999h]
		rol	eax, 0Bh
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+18h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+5A827999h]
		rol	edx, 9
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+3Ch]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+5A827999h]
		rol	ecx, 7
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+0Ch]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+5A827999h]
		rol	ebx, 0Fh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+30h]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+5A827999h]
		rol	eax, 7
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+5A827999h]
		rol	edx, 0Ch
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+24h]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+5A827999h]
		rol	ecx, 0Fh
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+14h]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+5A827999h]
		rol	ebx, 9
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+8]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+5A827999h]
		rol	eax, 0Bh
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+38h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+5A827999h]
		rol	edx, 7
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+2Ch]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+5A827999h]
		rol	ecx, 0Dh
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+20h]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+5A827999h]
		rol	ebx, 0Ch
		mov	ebp, ecx
		add	eax, [esi+0Ch]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+6ED9EBA1h]
		rol	eax, 0Bh
		mov	ebp, ebx
		add	edx, [esi+28h]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+6ED9EBA1h]
		rol	edx, 0Dh
		mov	ebp, eax
		add	ecx, [esi+38h]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+6ED9EBA1h]
		rol	ecx, 6
		mov	ebp, edx
		add	ebx, [esi+10h]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+6ED9EBA1h]
		rol	ebx, 7
		mov	ebp, ecx
		add	eax, [esi+24h]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+6ED9EBA1h]
		rol	eax, 0Eh
		mov	ebp, ebx
		add	edx, [esi+3Ch]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+6ED9EBA1h]
		rol	edx, 9
		mov	ebp, eax
		add	ecx, [esi+20h]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+6ED9EBA1h]
		rol	ecx, 0Dh
		mov	ebp, edx
		add	ebx, [esi+4]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+6ED9EBA1h]
		rol	ebx, 0Fh
		mov	ebp, ecx
		add	eax, [esi+8]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+6ED9EBA1h]
		rol	eax, 0Eh
		mov	ebp, ebx
		add	edx, [esi+1Ch]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+6ED9EBA1h]
		rol	edx, 8
		mov	ebp, eax
		add	ecx, [esi]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+6ED9EBA1h]
		rol	ecx, 0Dh
		mov	ebp, edx
		add	ebx, [esi+18h]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+6ED9EBA1h]
		rol	ebx, 6
		mov	ebp, ecx
		add	eax, [esi+34h]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+6ED9EBA1h]
		rol	eax, 5
		mov	ebp, ebx
		add	edx, [esi+2Ch]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+6ED9EBA1h]
		rol	edx, 0Ch
		mov	ebp, eax
		add	ecx, [esi+14h]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+6ED9EBA1h]
		rol	ecx, 7
		mov	ebp, edx
		add	ebx, [esi+30h]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+6ED9EBA1h]
		rol	ebx, 5
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+4]
		or	edi, ebp
		lea	eax, [eax+edi-70E44324h]
		rol	eax, 0Bh
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+24h]
		or	edi, ebp
		lea	edx, [edx+edi-70E44324h]
		rol	edx, 0Ch
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+2Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi-70E44324h]
		rol	ecx, 0Eh
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+28h]
		or	edi, ebp
		lea	ebx, [ebx+edi-70E44324h]
		rol	ebx, 0Fh
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi]
		or	edi, ebp
		lea	eax, [eax+edi-70E44324h]
		rol	eax, 0Eh
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+20h]
		or	edi, ebp
		lea	edx, [edx+edi-70E44324h]
		rol	edx, 0Fh
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+30h]
		or	edi, ebp
		lea	ecx, [ecx+edi-70E44324h]
		rol	ecx, 9
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+10h]
		or	edi, ebp
		lea	ebx, [ebx+edi-70E44324h]
		rol	ebx, 8
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+34h]
		or	edi, ebp
		lea	eax, [eax+edi-70E44324h]
		rol	eax, 9
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+0Ch]
		or	edi, ebp
		lea	edx, [edx+edi-70E44324h]
		rol	edx, 0Eh
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+1Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi-70E44324h]
		rol	ecx, 5
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+3Ch]
		or	edi, ebp
		lea	ebx, [ebx+edi-70E44324h]
		rol	ebx, 6
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+38h]
		or	edi, ebp
		lea	eax, [eax+edi-70E44324h]
		rol	eax, 8
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+14h]
		or	edi, ebp
		lea	edx, [edx+edi-70E44324h]
		rol	edx, 6
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+18h]
		or	edi, ebp
		lea	ecx, [ecx+edi-70E44324h]
		rol	ecx, 5
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+8]
		or	edi, ebp
		lea	ebx, [ebx+edi-70E44324h]
		rol	ebx, 0Ch
		mov	ds:dword_4042F4, ebx
		mov	ds:dword_4042F8, ecx
		mov	ds:dword_4042FC, edx
		mov	ds:dword_404300, eax
		mov	edx, ds:dword_4042F0
		mov	ebx, ds:dword_4042E8
		mov	eax, ds:dword_4042E4
		mov	ecx, ds:dword_4042EC
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+14h]
		or	edi, ebp
		lea	eax, [eax+edi+50A28BE6h]
		rol	eax, 8
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+38h]
		or	edi, ebp
		lea	edx, [edx+edi+50A28BE6h]
		rol	edx, 9
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+1Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi+50A28BE6h]
		rol	ecx, 9
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi]
		or	edi, ebp
		lea	ebx, [ebx+edi+50A28BE6h]
		rol	ebx, 0Bh
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+24h]
		or	edi, ebp
		lea	eax, [eax+edi+50A28BE6h]
		rol	eax, 0Dh
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+8]
		or	edi, ebp
		lea	edx, [edx+edi+50A28BE6h]
		rol	edx, 0Fh
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+2Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi+50A28BE6h]
		rol	ecx, 0Fh
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+10h]
		or	edi, ebp
		lea	ebx, [ebx+edi+50A28BE6h]
		rol	ebx, 5
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+34h]
		or	edi, ebp
		lea	eax, [eax+edi+50A28BE6h]
		rol	eax, 7
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+18h]
		or	edi, ebp
		lea	edx, [edx+edi+50A28BE6h]
		rol	edx, 7
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+3Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi+50A28BE6h]
		rol	ecx, 8
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+20h]
		or	edi, ebp
		lea	ebx, [ebx+edi+50A28BE6h]
		rol	ebx, 0Bh
		mov	ebp, edx
		mov	edi, ebx
		not	ebp
		and	edi, edx
		and	ebp, ecx
		add	eax, [esi+4]
		or	edi, ebp
		lea	eax, [eax+edi+50A28BE6h]
		rol	eax, 0Eh
		mov	ebp, ecx
		mov	edi, eax
		not	ebp
		and	edi, ecx
		and	ebp, ebx
		add	edx, [esi+28h]
		or	edi, ebp
		lea	edx, [edx+edi+50A28BE6h]
		rol	edx, 0Eh
		mov	ebp, ebx
		mov	edi, edx
		not	ebp
		and	edi, ebx
		and	ebp, eax
		add	ecx, [esi+0Ch]
		or	edi, ebp
		lea	ecx, [ecx+edi+50A28BE6h]
		rol	ecx, 0Ch
		mov	ebp, eax
		mov	edi, ecx
		not	ebp
		and	edi, eax
		and	ebp, edx
		add	ebx, [esi+30h]
		or	edi, ebp
		lea	ebx, [ebx+edi+50A28BE6h]
		rol	ebx, 6
		mov	ebp, ecx
		add	eax, [esi+18h]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+5C4DD124h]
		rol	eax, 9
		mov	ebp, ebx
		add	edx, [esi+2Ch]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+5C4DD124h]
		rol	edx, 0Dh
		mov	ebp, eax
		add	ecx, [esi+0Ch]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+5C4DD124h]
		rol	ecx, 0Fh
		mov	ebp, edx
		add	ebx, [esi+1Ch]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+5C4DD124h]
		rol	ebx, 7
		mov	ebp, ecx
		add	eax, [esi]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+5C4DD124h]
		rol	eax, 0Ch
		mov	ebp, ebx
		add	edx, [esi+34h]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+5C4DD124h]
		rol	edx, 8
		mov	ebp, eax
		add	ecx, [esi+14h]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+5C4DD124h]
		rol	ecx, 9
		mov	ebp, edx
		add	ebx, [esi+28h]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+5C4DD124h]
		rol	ebx, 0Bh
		mov	ebp, ecx
		add	eax, [esi+38h]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+5C4DD124h]
		rol	eax, 7
		mov	ebp, ebx
		add	edx, [esi+3Ch]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+5C4DD124h]
		rol	edx, 7
		mov	ebp, eax
		add	ecx, [esi+20h]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+5C4DD124h]
		rol	ecx, 0Ch
		mov	ebp, edx
		add	ebx, [esi+30h]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+5C4DD124h]
		rol	ebx, 7
		mov	ebp, ecx
		add	eax, [esi+10h]
		not	ebp
		or	ebp, ebx
		xor	ebp, edx
		lea	eax, [eax+ebp+5C4DD124h]
		rol	eax, 6
		mov	ebp, ebx
		add	edx, [esi+24h]
		not	ebp
		or	ebp, eax
		xor	ebp, ecx
		lea	edx, [edx+ebp+5C4DD124h]
		rol	edx, 0Fh
		mov	ebp, eax
		add	ecx, [esi+4]
		not	ebp
		or	ebp, edx
		xor	ebp, ebx
		lea	ecx, [ecx+ebp+5C4DD124h]
		rol	ecx, 0Dh
		mov	ebp, edx
		add	ebx, [esi+8]
		not	ebp
		or	ebp, ecx
		xor	ebp, eax
		lea	ebx, [ebx+ebp+5C4DD124h]
		rol	ebx, 0Bh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+3Ch]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+6D703EF3h]
		rol	eax, 9
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+14h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+6D703EF3h]
		rol	edx, 7
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+4]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+6D703EF3h]
		rol	ecx, 0Fh
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+0Ch]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+6D703EF3h]
		rol	ebx, 0Bh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+1Ch]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+6D703EF3h]
		rol	eax, 8
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+38h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+6D703EF3h]
		rol	edx, 6
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+18h]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+6D703EF3h]
		rol	ecx, 6
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+24h]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+6D703EF3h]
		rol	ebx, 0Eh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+2Ch]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+6D703EF3h]
		rol	eax, 0Ch
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi+20h]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+6D703EF3h]
		rol	edx, 0Dh
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+30h]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+6D703EF3h]
		rol	ecx, 5
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+8]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+6D703EF3h]
		rol	ebx, 0Eh
		mov	edi, ebx
		mov	ebp, ebx
		and	edi, ecx
		not	ebp
		add	eax, [esi+28h]
		and	ebp, edx
		or	edi, ebp
		lea	eax, [eax+edi+6D703EF3h]
		rol	eax, 0Dh
		mov	edi, eax
		mov	ebp, eax
		and	edi, ebx
		not	ebp
		add	edx, [esi]
		and	ebp, ecx
		or	edi, ebp
		lea	edx, [edx+edi+6D703EF3h]
		rol	edx, 0Dh
		mov	edi, edx
		mov	ebp, edx
		and	edi, eax
		not	ebp
		add	ecx, [esi+10h]
		and	ebp, ebx
		or	edi, ebp
		lea	ecx, [ecx+edi+6D703EF3h]
		rol	ecx, 7
		mov	edi, ecx
		mov	ebp, ecx
		and	edi, edx
		not	ebp
		add	ebx, [esi+34h]
		and	ebp, eax
		or	edi, ebp
		lea	ebx, [ebx+edi+6D703EF3h]
		rol	ebx, 5
		mov	edi, ebx
		add	eax, [esi+20h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 0Fh
		mov	edi, eax
		add	edx, [esi+18h]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 5
		mov	edi, edx
		add	ecx, [esi+10h]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 8
		mov	edi, ecx
		add	ebx, [esi+4]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 0Bh
		mov	edi, ebx
		add	eax, [esi+0Ch]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 0Eh
		mov	edi, eax
		add	edx, [esi+2Ch]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 0Eh
		mov	edi, edx
		add	ecx, [esi+3Ch]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 6
		mov	edi, ecx
		add	ebx, [esi]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 0Eh
		mov	edi, ebx
		add	eax, [esi+14h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 6
		mov	edi, eax
		add	edx, [esi+30h]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 9
		mov	edi, edx
		add	ecx, [esi+8]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 0Ch
		mov	edi, ecx
		add	ebx, [esi+34h]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 9
		mov	edi, ebx
		add	eax, [esi+24h]
		xor	edi, ecx
		xor	edi, edx
		add	eax, edi
		rol	eax, 0Ch
		mov	edi, eax
		add	edx, [esi+1Ch]
		xor	edi, ebx
		xor	edi, ecx
		add	edx, edi
		rol	edx, 5
		mov	edi, edx
		add	ecx, [esi+28h]
		xor	edi, eax
		xor	edi, ebx
		add	ecx, edi
		rol	ecx, 0Fh
		mov	edi, ecx
		add	ebx, [esi+38h]
		xor	edi, edx
		xor	edi, eax
		add	ebx, edi
		rol	ebx, 8
		add	edx, ds:dword_4042F8
		add	eax, ds:dword_4042FC
		add	edx, ds:dword_4042E8
		add	eax, ds:dword_4042EC
		add	ebx, ds:dword_404300
		mov	ds:dword_4042E8, eax
		add	ebx, ds:dword_4042F0
		add	ecx, ds:dword_4042F4
		mov	ds:dword_4042EC, ebx
		add	ecx, ds:dword_4042E4
		mov	ds:dword_4042E4, edx
		mov	ds:dword_4042F0, ecx
		sub	ds:dword_404308, 40h
		add	esi, 40h
		jmp	loc_401045

loc_401B85:	
		cmp	ds:byte_40430C,	0
		jz	short loc_401B98
		call	helper2
		jmp	loc_401045

loc_401B98:	
		mov	edi, [esp+20h+hashresult]
		mov	esi, offset dword_4042E4
		mov	ecx, 4
		rep movsd
		call	helper1 
		popa
		retn	0Ch
RIPEMD128	endp

helper1 proc near
		mov	edi, offset dword_404260
		mov	ecx, 2Ch
		xor	eax, eax
		rep stosd
		retn
helper1 endp

helper2 proc near
		mov	ecx, ds:dword_404308
		mov	ds:byte_40430C,	0
		mov	ds:dword_404308, 40h
		mov	eax, ecx
		mov	edi, offset byte_404264
		test	eax, eax
		jz	short loc_401BE4
		rep movsb

loc_401BE4:	
		mov	ecx, eax
		mov	byte ptr [edi],	80h
		sub	ecx, 37h
		inc	edi
		neg	ecx
		jz	short loc_401C01
		jns	short loc_401BFD
		add	ds:dword_404308, 40h
		add	ecx, 40h

loc_401BFD:
		xor	al, al
		rep stosb

loc_401C01:
		xor	edx, edx
		mov	eax, ds:dword_404304
		imul	eax, 8
		mov	[edi], eax
		mov	[edi+4], edx
		mov	esi, offset byte_404264
		retn
helper2 endp

end